<p>
I am a programmer. I am an engineer. I solve problems - all kinds of problems, not necessarily the ones that involve software or machines.  Given some time and space, I first observe, then I tweak, and while doing that I learn, understand and master any system. I am nimble and I get things done.
</p>

<p>
I am a Rubyist. I have been earning my bread and butter by building high performance, scalable and stable backends/API servers/admin-interfaces for a number of web/mobile applications primarily using Ruby on Rails.  At times when Ruby/Rails’s limitations comes in my way, my first instinct is to delegate the processing to a queue and throw more worker processes and hardware at it. But the under-utilisation of CPU of the machines, memory bloat and inability to perform tasks concurrently and fast lead me to Elixir, a concurrent functional language that runs on top of the battle tested Erlang VM. Building microservices in Elixir, Python, C++ or any other language/runtime that communicate with RoR via message queues, HTTP or the database, is my way of solving problems which can’t be solved efficiently with Ruby. This makes me happy as I can still continue programming in Ruby, while not being limited by it. 
</p>

<p>
I am a developer interested in the backend of the software system. I have built some interactive, responsive web interfaces whenever necessary, though the problems and challenges in the backend is where my interest and skills naturally lie. I write code in Javascript, and React in particular has caught my attention. I would admit that making things look beautiful - aesthetics - is not my cup of tea. But given a CSS pattern library (like bootstrap or a custom made one or some sample views in the app), I would use it consistently and build UIs that work and look decent.
</p>

<p>
Having used Linux machines from college days, I am comfortable and used to Unixes. I am on a Mac since last many years, but I have been setting up and deploying applications on Linux servers all the time. I have deployed applications to single machines, and also to a cluster of EC2 instances sitting behind load balancers, with automatic provisioning tools like Chef/Puppet and deployment automation tools like Capistrano. Most of the time I never had a separate devops team to setup and maintain the servers that my applications ran on. 
</p>

<p>
I have worked with product development companies most of my career, except during my freelancing stints. I have lead diverse development teams and been part of them - in both remote and in-office environments. I have enjoyed taking up large and complex projects, worked closely with the clients/business stakeholders and the development team simultaneously, divide/conquer and executed the project with continuous deployment. As much as I have seen of myself, I don’t buckle under pressure and those times bring out the best in me - be it live production issues or project deadlines.
</p>

<p>
Pursuing my interest in electronics from childhood, I dabble with electronic sensors and circuits, soldering, programming microcontrollers, wifi modules, Arduino, RaspberryPI and such. I can control lights of my home from a web app accessible through the internet - so I have introduced myself to the IoT (Internet of things) scene. 
</p>

<p>Some areas which I particularly lack experience are:</p>

<ul>
  <li>Machine/Deep learning</li>
  <li>Big Data analysis</li>
  <li>Plethora of JS libraries and build tools. </li>
  <li>Functional programming languages (my head is still not wrapped around FP constructs even though I play with Elixir and some Common Lisp)</li>
  <li>Block Chain</li>
  <li>Sketch/Photoshop/Mockup to HTML/CSS conversion</li>
  <li>The list could go on, but these are the ones, the lack of which has caused me embarrassment at times. </li>
</ul>